package dev.shadowsoffire.apotheosis.village.fletching;

package .tmp;

import dev.shadowsoffire.apotheosis.Apoth;
import dev.shadowsoffire.apotheosis.village.VillageModule;
import java.util.List;
import net.minecraft.core.NonNullList;
import net.minecraft.core.RegistryAccess;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.Container;
import net.minecraft.world.inventory.CraftingContainer;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.crafting.Recipe;
import net.minecraft.world.item.crafting.RecipeSerializer;
import net.minecraft.world.item.crafting.RecipeType;
import net.minecraft.world.level.Level;

public class FletchingRecipe implements Recipe<CraftingContainer> {
  protected final ResourceLocation id;
  
  protected final ItemStack output;
  
  protected final NonNullList<Ingredient> inputs = NonNullList.m_122780_(3, Ingredient.f_43901_);
  
  public FletchingRecipe(ResourceLocation id, ItemStack output, List<Ingredient> inputs) {
    this.id = id;
    this.output = output;
    for (int i = 0; i < Math.min(3, inputs.size()); i++)
      this.inputs.set(i, inputs.get(i)); 
  }
  
  public boolean matches(CraftingContainer inv, Level world) {
    for (int i = 0; i < 3; i++) {
      if (!((Ingredient)this.inputs.get(i)).test(inv.m_8020_(i)))
        return false; 
    } 
    return true;
  }
  
  public ItemStack assemble(CraftingContainer inv, RegistryAccess reg) {
    return this.output.m_41777_();
  }
  
  public boolean m_8004_(int width, int height) {
    return (width == 1 && height == 3);
  }
  
  public ItemStack m_8043_(RegistryAccess reg) {
    return this.output;
  }
  
  public ResourceLocation m_6423_() {
    return this.id;
  }
  
  public RecipeSerializer<?> m_7707_() {
    return VillageModule.FLETCHING_SERIALIZER;
  }
  
  public RecipeType<?> m_6671_() {
    return Apoth.RecipeTypes.FLETCHING;
  }
  
  public NonNullList<Ingredient> m_7527_() {
    return this.inputs;
  }
  
  public ItemStack getOutput() {
    return this.output;
  }
}
